
Cls
Mode 3

'load support files
Sprite Load "ball.spr"
Font Load "brick32.fnt" As #6
Font Load "bat48.fnt" As #8

'set up hardware
SetPin 1,1 'pin 1 is analog paddle input

'initialize variables
level = 1
score = 0
brickcount = 0
balleft = 3
Dim bricks(14,7)
demomode = 1
easymode = 0
delta = 0

'draw screen
colour = Purple
Line (4,MM.VRes - 13) - (0,20) , Purple, BF
Line (MM.HRes - 4,MM.VRes - 13) - (MM.HRes,20), Purple, BF
Line (0,20) - (MM.HRes,39), Purple, BF
Font #2
Print @(20,0) CLR$(Red) "MaxiBrick";
Print @(180,250) CLR$(Green) "Demo Mode"
Font #1
Print @(175,270) CLR$(Green) "press a key to play..."
Print @(10,25) CLR$(Black, Purple) "Bricks Left:"
Print @(145,25) CLR$(Black, Purple) "Balls:"
Print @(275,25) CLR$(Black, Purple) "Level:"
Print @(380,25) CLR$(Black, Purple) "Score:"
Print @(165,6) CLR$(Yellow) "by Vegipete"
Print @(260,6) CLR$(Cyan) "picprog.strongedge.net"
UpdateScrn

xposn = Int(Pin(1) * 470 / 3.3) - 20
yposn = MM.VRes - 12
Font #8
Print @(xposn,yposn) "0" 'draw the bat at the bottom
xball = xposn + 16
xinc = .3
yball = MM.VRes -27
yinc = -1
Sprite on 1,xball,yball
DrawBricks
Do
  Timer = 0

  'Update ball position
  xball = xball + xinc
  yball = yball + yinc
  Sprite move 1,xball,yball

  'Update bat position
  If demomode Then
    xposnew = xball - 24 + delta
  Else
    xposnew = Int(Pin(1) * 470 / 3.3) - 20
  EndIf
  If Abs(xposnew - xposn) > 2 Then
    Font #8
    Print @(xposn,yposn) "1"        'erase the old bat
    Print @(xposnew,yposn) "0"      'draw new bat
    xposn = xposnew
  EndIf

  'Test ball at edges of playing area
  If (xball < 5) Then xinc = Abs(xinc)
  If (xball > MM.HRes - 20) Then xinc = - Abs(xinc)
  If (yball < 40) Then yinc = Abs(yinc)     'Top of screen?

  'Test ball hitting (or missing) bat
  If (yball > MM.VRes - 27) Then        'Ball at bottom of screen?
    If (xball > xposn - 16) And (xball < xposn + 48) Then  'Ball hitting bat?
      yinc = -Abs(yinc)
      spin = xball - xposn - 15
      xinc = xinc + spin / 20
      If xinc > 1.6 Then xinc = 1.6
      If xinc < -1.6 Then xinc = -1.6
      delta = Rnd(1) * 16
    Else    'missed the ball
      Sprite off balleft + 1
      balleft = balleft - 1
      If balleft = 0 Then
        EndGame   'game over >:-(
      Else
        yinc = -1
        xinc = .3
        xball = xposn + 16
        Pause 2000
      EndIf
    EndIf
  EndIf

  'Test for ball hitting bricks
  i = Int((xball - 4) / 33) + 1
  k = Int((yball - 74) / 12)
  If k < 8 And k > 0 Then
    If bricks(i, k) Then
      score = score + 1
      brickcount = brickcount - 1
      yinc = -yinc
      Font #2
      Print @(87,20) CLR$(Black, Purple) Format$(brickcount, "%03G")
      If demomode = 0 Then
        Print @(420,20) CLR$(Black, Purple) Format$(score, "%04G")
      EndIf
      Font #6
      Sprite off 1
      Print @(i*33 - 24, k*12 + 80) CLR$(bricks(i,k)) "1"  'Erase brick
      Sprite on 1 , xball, yball
      bricks(i,k) = 0
      If brickcount = 0 Then
        level = level + 1
        Font #2
        Print @(120,120) CLR$(Yellow) "ALL BRICKS SMASHED!"
        Pause 2000
        Print @(120,120) CLR$(Black ) "                   "
        If demomode = 0 Then
          Print @(315,20) CLR$(Black, Purple) Format$(level, "%03G")
        EndIf
        Sprite off 1
        DrawBricks
        Sprite on 1 , xball, yball
      EndIf
    EndIf
  EndIf

  'Scroll title - NO WAY, FAR TOO SLOW!
  'BLIT 0,0,479,0,1,19
  'BLIT 1,0,0,0,479,19

  kp = Asc(Inkey$)
  'Test for keypress during demo mode to start a new game
  If (demomode=1) And (kp<>0) Then
    easymode = 0
    If kp = 101 Then easymode = 1
    If kp <> 27 Then StartNew
  EndIf

  'Wait for fixed time so animation is smooth
  Do
  Loop Until Timer > 3
  If easymode Then
    Do
    Loop Until Timer > 7
  EndIf

Loop Until kp = 27
End

'Set everything up to start a new game
Sub StartNew
  Local i

  score = 0
  level = 1
  brickcount = 0
  balleft = 3
  demomode = 0
  UpdateScrn
  DrawBricks

  'draw the players balls
  For i = 0 To balleft-1 : Sprite on 2+i,185+18*i,22 : Next

  'read current paddle position and draw bat
  Font #8
  Print @(xposn,yposn) "1"      'erase the old bat
  xposn = Int(Pin(1) * 470 / 3.3) - 20
  Print @(xposn,yposn) "0"      'draw new bat

  'set up starting ball position and speed
  xball = xposn + 16
  xinc = 0    'straight up
  yball = MM.VRes -27
  yinc = -1
  Sprite move 1,xball,yball

  'erase demo mode message
  Line (175,250)-(304,280),Black,bf

End Sub

'Game over - so sad
Sub EndGame
  Font #2
  Print @(175,200) CLR$(Red) "GAME OVER"
  Pause 1000
  'Now scroll "GAME OVER" off bottom of screen
  For i = 201 To 432
    Print @(175,i) CLR$(Red) "GAME OVER"
  Next
  demomode = 1    'demo mode will continue from where the game ended
  easymode = 0
  Print @(180,250) CLR$(Green) "Demo Mode"
  Font #1
  Print @(175,270) CLR$(Green) "press a key to play..."
End Sub

'Update all onscreen values
Sub UpdateScrn
  Local i

  Font #2
  Print @(315,20) CLR$(Black, Purple) Format$(level, "%03G")
  Print @(420,20) CLR$(Black, Purple) Format$(score, "%04G")
  Print @(87,20) CLR$(Black, Purple) Format$(brickcount, "%03G")
End Sub

'Fill the array with bricks and draw them on the screen
Sub DrawBricks
  brickcount = 0
  For i = 1 To 14
    Font #6
    For k = 1 To 7
      bricks(i,k) = k
      Print @(i*33 - 24, k*12 + 80) CLR$(bricks(i,k)) "0"
      brickcount = brickcount + 1
    Next k
    Font #2
    Print @(87,20) CLR$(Black, Purple) Format$(brickcount, "%03G")
  Next i
End Sub

